<?php namespace Concrete\Package\GifPlayr\Block\GifPlayr;
use \Concrete\Core\Block\BlockController;
use Concrete\Core\Support\Facade\Application;
use File; 

class Controller extends BlockController
{
    protected $btTable = 'btGifplayr';
    protected $btInterfaceWidth = "560";
	protected $btInterfaceHeight = "400";
    protected $btWrapperClass = 'ccm-ui';
	protected $btDefaultSet = 'multimedia';
	public $fID = "";

    public function getBlockTypeDescription(){
        return t("Display an animated GIF image.");
    }

    public function getBlockTypeName(){
        return t("GIF Playr");
    }
	
	public function add() { $this->edit(); }
	public function edit() {
		$this->set('app', Application::getFacadeApplication());
	}

	public function registerViewAssets($outputContent = '') {
        $this->requireAsset('javascript', 'jquery');
    }
	public function getFileID() {
        return $this->fID;
    }
	public function getFileObject() {
        return File::getByID($this->fID);
    }
	public function on_start() {
		if(!is_object($this->app)){
			$this->app = \Concrete\Core\Support\Facade\Application::getFacadeApplication();
			$this->set('app', $this->app);
		}
	}
	public function view() {
		$al = \Concrete\Core\Asset\AssetList::getInstance();
        $al->register('javascript', 'jquery.freezeframe', 'blocks/gif_playr/js/freezeframe.pkgd.js', array('version' => '3.0.10', 'minify' => true), 'gif_playr');
        $this->requireAsset('javascript', 'jquery.freezeframe');
		$f = $this->getFileObject();
        $this->set('f', $f);
	}
	public function validate($args) {
        if (!is_object($this->app)) {
            $app = Application::getFacadeApplication();
        } else {
            $app = $this->app;
        }
		$e = $app->make('error');     
		if(!ctype_digit(trim($args['apd']))){
            $e->add(t("Play duration must be numeric only."));
        }
		$f = $this->getFileObject();
        $this->set('f', $f);
		if (is_object($f)) {
			if(empty($args['fID'])){
				$e->add(t("GIF Image is required."));
			} elseif (!empty($args['fID'])) {
				$f = File::getByID($args['fID']); // Get the file	
				$fv = $f->getVersion();  // Get the file version
				$fileType = $fv->getExtension();  // Get the file extension
				$ftypes = array("gif", "GIF"); // Define array of file types.
				if(!in_array($fileType, $ftypes)) {   // If the file extension is NOT in the array, return this error.
					$e->add(t("Invalid image type. Please select a GIF file."));
				}
			}
			return $e;
		}
    }

}